Subject: [PATCH-V6 3/3] ARM: OMAP: Make OMAP clocksource source selection using kernel param

From: [email-masked] (Kevin Hilman)
Date: Wed, 02 May 2012 13:39:59 -0700

Vaibhav Hiremath <[email-masked]> writes:

> Current OMAP code supports couple of clocksource options based
> on compilation flag (CONFIG_OMAP_32K_TIMER). The 32KHz sync-timer
> and a gptimer which can run on 32KHz or system clock (e.g 38.4 MHz).
> So there can be 3 options -
>
> 1. 32KHz sync-timer
> 2. Sys_clock based (e.g 13/19.2/26/38.4 MHz) gptimer
> 3. 32KHz based gptimer.
>
> The optional gptimer based clocksource was added so that it can
> give the high precision than sync-timer, so expected usage was 2
> and not 3.
> Unfortunately option 2, clocksource doesn't meet the requirement of
> free-running clock as per clocksource need. It stops in low power states
> when sys_clock is cut. That makes gptimer based clocksource option
> useless for OMAP2/3/4 devices with sys_clock as a clock input.
> So, in order to use option 2, deeper idle state MUST be disabled.
>
> Option 3 will still work but it is no better than 32K sync-timer
> based clocksource.
>
> We must support both sync timer and gptimer based clocksource as
> some OMAP based derivative SoCs like AM33XX does not have the
> sync timer.
>
> Considering above, make sync-timer and gptimer clocksource runtime
> selectable so that both OMAP and AMXXXX continue to use the same code.
>
> And, in order to precisely configure/setup sched_clock for given
> clocksource, decision has to be made early enough in boot sequence.
>
> So, the solution is,
>
> Use standard kernel parameter ("clocksource=") to override
> default 32k_sync-timer, in addition to this, we also use hwmod database
> lookup mechanism, through which at run-time we can identify availability
> of 32k-sync timer on the device, else fall back to gptimer.
>
> Also, moved low-level SoC specific init code to respective files,
> (mach-omap1/timer32k.c and mach-omap2/timer.c)
>
> Signed-off-by: Vaibhav Hiremath <[email-masked]>
> Signed-off-by: Felipe Balbi <[email-masked]>
> Reviewed-by: Santosh Shilimkar <[email-masked]>
> Cc: Benoit Cousson <[email-masked]>
> Cc: Tony Lindgren <[email-masked]>
> Cc: Paul Walmsley <[email-masked]>
> Cc: Kevin Hilman <[email-masked]>
> Cc: Tarun Kanti DebBarma <[email-masked]>
> Cc: Ming Lei <[email-masked]>

Reviewed-by: Kevin Hilman <[email-masked]>
Tested-by: Kevin Hilman <[email-masked]>

tested on OMAP3530/Overo with default 32k timer and cmdline override for
GPtimer.

Kevin